using FluentValidation;
using CMSMicroservice.Protobuf.Protos.User;
namespace CMSMicroservice.Protobuf.Validator.User;

public class CreateNewUserRequestValidator : AbstractValidator<CreateNewUserRequest>
{
    public CreateNewUserRequestValidator()
    {
        RuleFor(model => model.Mobile)
            .NotEmpty();
        RuleFor(model => model.EmailNotifications)
            .NotNull();
        RuleFor(model => model.SmsNotifications)
            .NotNull();
        RuleFor(model => model.PushNotifications)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserRequest>.CreateWithOptions((CreateNewUserRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
